package nova.monadic_sfx.util.controls

import com.jfoenix.{controls => jfoenixc}
import scalafx.Includes._
import scalafx.beans.property.BooleanProperty
import scalafx.scene.control.TextField
import scalafx.scene.paint.Paint

object JFXTextField {
  implicit def sfxTextField2jfx(v: JFXTextField): jfoenixc.JFXTextField =
    if (v != null) v.delegate else null
}

// TextInputControl(delegate)
//     with AlignmentDelegate[jfoenixc.JFXTextField]
//     with SFXDelegate[jfoenixc.JFXTextField] {

class JFXTextField(
    override val delegate: jfoenixc.JFXTextField = new jfoenixc.JFXTextField
) extends TextField(delegate) {

  def labelFloat = delegate.labelFloatProperty()
  def labelFloat_=(v: Boolean) = delegate.setLabelFloat(v)

  def focusColor: Paint = delegate.getFocusColor()
  def focusColor_=(color: Paint) = delegate.setFocusColor(color)

  def unFocusColor = delegate.getUnFocusColor()
  def unFocusColor_=(color: Paint) = delegate.setUnFocusColor(color)

  def disableAnimation: BooleanProperty = delegate.disableAnimationProperty()

  def disableAnimation_=(disable: Boolean) =
    delegate.setDisableAnimation(disable)
}
